#pragma once
#include <libmegapixels.h>
#include <stdbool.h>

typedef struct state_main {
        libmegapixels_devconfig *configuration;
        libmegapixels_camera *camera;

        // Size of the preview widget
        int preview_width;
        int preview_height;

        // Size of the frame to draw in the preview widget
        int preview_buffer_width;
        int preview_buffer_height;

        int device_rotation;

        int burst_length;

        // Control state
        bool gain_is_manual;
        int gain;
        int gain_max;

        bool exposure_is_manual;
        int exposure;

        bool flash_enabled;

        bool has_auto_focus_continuous;
        bool has_auto_focus_start;
} mp_state_main;